#!/usr/bin/env python3
#-*- coding: iso-8859-15 -*-

##----------------------------------------------------------------------------------------------
## Coban - lanceur principal
## Copyright 2008-2010  Stphan GURIN
## contact : setthe@gmail.com
##
## Ce logiciel est un programme informatique destin aux lectriciens et 
## permettant de calculer rapidement la section d'un cble, de raliser des
## conversions d'units lectriques, etc.... 
##
## Ce logiciel est rgi par la licence CeCILL soumise au droit franais et
## respectant les principes de diffusion des logiciels libres. Vous pouvez
## utiliser, modifier et/ou redistribuer ce programme sous les conditions
## de la licence CeCILL telle que diffuse par le CEA, le CNRS et l'INRIA 
## sur le site "http://www.cecill.info".
##
## En contrepartie de l'accessibilit au code source et des droits de copie,
## de modification et de redistribution accords par cette licence, il n'est
## offert aux utilisateurs qu'une garantie limite.  Pour les mmes raisons,
## seule une responsabilit restreinte pse sur l'auteur du programme,  le
## titulaire des droits patrimoniaux et les concdants successifs.
##
## A cet gard  l'attention de l'utilisateur est attire sur les risques
## associs au chargement,   l'utilisation,   la modification et/ou au
## dveloppement et  la reproduction du logiciel par l'utilisateur tant 
## donn sa spcificit de logiciel libre, qui peut le rendre complexe  
## manipuler et qui le rserve donc  des dveloppeurs et des professionnels
## avertis possdant  des  connaissances  informatiques approfondies.  Les
## utilisateurs sont donc invits  charger  et  tester  l'adquation  du
## logiciel  leurs besoins dans des conditions permettant d'assurer la
## scurit de leurs systmes et ou de leurs donnes et, plus gnralement, 
##  l'utiliser et l'exploiter dans les mmes conditions de scurit. 
##
## Le fait que vous puissiez accder  cet en-tte signifie que vous avez 
## pris connaissance de la licence CeCILL, et que vous en avez accept les
## termes.
##
##----------------------------------------------------------------------------------------------


Version = "1.2.0+"


############################################################################
##                                                                        ##
##           LANCEUR PRINCIPAL DU LOGICIEL COBAN                          ##
##                                                                        ##
############################################################################

try :
    import wx
    from   wx.adv import SplashScreen as SplashScreen
except :
    print (u"Coban requires the installation of wxPython to operate")
    raw_input()

from modcoban import icone, testFich, fichierConf
import os, sys, pickle


# ------------ Dmarrage ----------------------#
    
# teste si le dossier .coban de l'utilisateur existe, sinon le cre
dossierParDef = os.path.join(os.path.expanduser("~"),'.coban')
if os.path.exists(dossierParDef) == False:
    os.mkdir(dossierParDef)

#-----------------------------------------------------------------------------------

def changeDir():
    """ conversion du rpertoire courant en rpertoire de travail """
    chemin = os.getcwd()
    os.chdir(chemin)

#--------------------------------------------------------------------------------------

def TestLicence():
    """ teste si la licence est active 
    (uniquement pour la version "excutable" pour Windows(R)).\n
    --> retourne 1 si licence OK, 0 sinon."""
    
    return 1
    

#--------------------------------------------------------------------------------------

def opj(path):
    """Convert paths to the platform-specific separator"""
    st = apply(os.path.join, tuple(path.split('/')))
    # HACK: on Linux, a leading / gets lost...
    if path.startswith('/'):
        st = '/' + st
    return st

#---------------------------------------------------------------------------

class MySplashScreen(SplashScreen):
    def __init__(self):
        bmp = wx.Image(opj("images/coban_maj.png")).ConvertToBitmap()
        wx.SplashScreen.__init__(self, bmp,
                                 wx.SPLASH_CENTRE_ON_SCREEN | wx.SPLASH_TIMEOUT,
                                 3000, None, -1)
        self.Bind(wx.EVT_CLOSE, self.OnClose)
        self.fc = wx.FutureCall(2000, self.ShowMain)


    def OnClose(self, evt):
        # Make sure the default handler runs too so this window gets
        # destroyed
        evt.Skip()
        self.Hide()
        
        # if the timer is still running then go ahead and show the
        # main frame now
        if self.fc.IsRunning():
            self.fc.Stop()
            self.ShowMain()


    def ShowMain(self):
##        frame = wxPythonDemo(None, "wxPython: (A Demonstration)")
##        frame.Show()
        if self.fc.IsRunning():
            self.Raise()




#---------------------------------------------------------------------------

class Coban(wx.App):
    """Main-Application"""
    def OnInit(self):
        # cration de la fentre principale
        frame = Principale("Coban")         
        # insertion de l'icone de l'application 
        icone(frame)
        frame.Show(True)
        self.SetTopWindow(frame)
        changeDir()
        return True


#--------------------------------------------------------------------------------------


class Principale(wx.Frame):
    """Main launcher of the different modules"""
    def __init__(self, titre):
        wx.Frame.__init__(self, None, -1, title = titre,
                      style=wx.DEFAULT_FRAME_STYLE 
                      ^(wx.RESIZE_BORDER | wx.MAXIMIZE_BOX))
        
        # test if the default path of the configuration file exists
        try :
            f = open(fichierConf, 'rb')
            self.cheminParDef = pickle.load(f)
            self.Maj = pickle.load(f)
            f.close()
        except :
            try :
                self.cheminParDef = os.path.join(os.path.expanduser('~'), '.coban')
                self.Maj = 1
                f = open(fichierConf, 'w')
                pickle.dump(self.cheminParDef, f)
                pickle.dump(self.Maj, f)
                f.close()
                
            except :
                wx.MessageBox(u"You do not have the rights to write to:\n%s\n\n"
                              u"Some modules will not work. \n\n"
                              u"Contact your system administrator to give you the rights, "
                              u"or manually modify the file:\n%s\n\n"
                              u"(see the Coban help or the site: \n"
                              u"http://sg-logiciels.fr pour plus d'informations)." %(os.getcwd(), os.path.join(os.getcwd(), fichierConf)),
                              u'Error!',
                              wx.ICON_WARNING)
                self.cheminParDef = os.path.join(os.path.expanduser('~'), '.coban')
                
        #------------- teste la licence au dmarrage -------------#
        #-------------- (pour windows uniquement) ----------------#
        self.licence_ok = TestLicence()
        #---------------------------------------------------------#
        
        
        ############## Cration du panel #########################
        
        panel =  wx.Panel(self, -1, style = wx.TAB_TRAVERSAL
                     | wx.CLIP_CHILDREN
                     | wx.FULL_REPAINT_ON_RESIZE
                     )
        
        ############## cration du sizer principal ###############
        
        self.gbs = wx.GridBagSizer(hgap=5, vgap=5)
        
        ############## Cration de statusbar #####################
        
        self.CreateStatusBar()
        self.SetStatusText("See help for more information on the modules")
        
        ################# CRATION DES MENUS #######################
        
        barreMenu = wx.MenuBar()
        
        # Menu des modules
        self.menuModule = wx.Menu()
        
        # sous-menu "lectricit" ---------------------------------------------------------------------
        self.sousMenuCalcul = wx.Menu()
        # module section
        self.menuModuleSection = self.sousMenuCalcul.Append(wx.ID_ANY, u"Cross-section",
                                              u"Calculate cross-section of cable")
        self.Bind(wx.EVT_MENU, self.onSection, self.menuModuleSection)
        # module chute
        self.menuModuleChute = self.sousMenuCalcul.Append(wx.ID_ANY, u"Voltage drop",
                                              u"Calculate voltage drop")
        self.Bind(wx.EVT_MENU, self.onChute, self.menuModuleChute)
        
        self.menuModule.Append(-1, u"Electricity", self.sousMenuCalcul)
        self.menuModule.AppendSeparator()
        
        # sous-menu "Conversions" ---------------------------------------------------------------------
        self.sousMenuConv = wx.Menu()
        # module conversion
        self.menuModuleConversion = self.sousMenuConv.Append(wx.ID_ANY, u"Conversions W/A/CV/HP", 
                                                 u"Conversions Watts / Ampres / Chevaux / Horse Power")
        self.Bind(wx.EVT_MENU, self.onConversion, self.menuModuleConversion)
        # module AWG
        self.menuModuleConvAwg = self.sousMenuConv.Append(wx.ID_ANY, u"Conversion AWG", 
                                                 u"Conversion de l'AWG vers mm2")
        self.Bind(wx.EVT_MENU, self.onConvAwg, self.menuModuleConvAwg)

        self.menuModule.Append(-1, u"Conversions", self.sousMenuConv)
        self.menuModule.AppendSeparator()
        
        # sous-menu "Sono-Vido" ---------------------------------------------------------------------------
        self.sousMenuSonoVideo = wx.Menu()
        # module Vido
        self.menuModuleVideo = self.sousMenuSonoVideo.Append(wx.ID_ANY, u"Calculs de champs de vision",
                                                      u"Calculs de champs de vision en fonction de focales et de distances")
        self.Bind(wx.EVT_MENU, self.onVideo, self.menuModuleVideo)
        # module sono
        self.menuModuleSono = self.sousMenuSonoVideo.Append(wx.ID_ANY, u"HP et puissances",
                                                      u"Calculs du nombre de HP et de la puissance ncessaire")
        self.Bind(wx.EVT_MENU, self.onSono, self.menuModuleSono)
        
        self.menuModule.Append(-1, u"Sono / Vido", self.sousMenuSonoVideo)
        self.menuModule.AppendSeparator()
        
        # sous-menu "Climatic" -------------------------------------------------------------------------------------
        self.sousMenuClimatic = wx.Menu()
        # module climatic
        self.menuModuleChauffage = self.sousMenuClimatic.Append(wx.ID_ANY, u'Bilans thermiques',
                                                          u"Calculer la puissance ncessaire pour chauffer ou climatiser une pice.")
        self.Bind(wx.EVT_MENU, self.onClimatic, self.menuModuleChauffage)
        
        self.menuModule.Append(-1, u"Chauffage/Climatisation", self.sousMenuClimatic)
        self.menuModule.AppendSeparator()
        
        # sous-menu "clairage" ------------------------------------------------------------------------------------
        self.sousMenuEclairage = wx.Menu()
        # module clairage
        self.menuModuleEcl = self.sousMenuEclairage.Append(wx.ID_ANY, u"Interior lighting",
                                                           u"Calculate the number of luminaires required \n"
                                                           u"for the desired level of illumination")
        self.Bind(wx.EVT_MENU, self.onEclairage, self.menuModuleEcl)
        
        self.menuModule.Append(-1, u"Lighting", self.sousMenuEclairage)
        self.menuModule.AppendSeparator()
        
        # menu quitter ----------------------------------------------------------------------------------------------
        self.menuModuleQuitter = self.menuModule.Append(wx.ID_EXIT, "Quit", "Quit application...")
        self.Bind(wx.EVT_MENU, self.onQuitter, self.menuModuleQuitter)
        
        # Menu Aide --------------------------------------------------------------------------------------------
        
        menuAide = wx.Menu()
        
        # sous-menu "aide"
        menuAideAide = menuAide.Append(wx.ID_HELP,'Help', u"Help on the software")
        self.Bind(wx.EVT_MENU, self.onAide, menuAideAide)

        # sous-menu "Prfrences" 
        self.menuPreferences = wx.Menu()
        # dossier de sauvegarde
        self.menuPreferencesSauvegarde = self.menuPreferences.Append(-1, u"Backup directory", u"Choice of the saving directory")
        self.Bind(wx.EVT_MENU, self.onPreferencesSauvegarde, self.menuPreferencesSauvegarde)        
        # Mises  jour auto
        self.menuMaJauto = self.menuPreferences.Append(-1, u"Preventing updates", u"Prevent automatic updates", wx.ITEM_CHECK)
        self.menuMaJauto.Check(self.Maj)
        self.Bind(wx.EVT_MENU, self.onMaJ, self.menuMaJauto)
        
        menuAide.Append(wx.ID_PREFERENCES, u"Preferences", self.menuPreferences)
        menuAide.AppendSeparator()
        
        ############################ Registration of the licence ###############################
        ############################ only for Windows - Version!  ##############################
        menuAideEnregistrer = menuAide.Append(wx.ID_APPLY, u'Registration', u'Registrer Coban')
        self.Bind(wx.EVT_MENU, self.onEnregistrement, menuAideEnregistrer)
        menuAide.AppendSeparator()
        ##############################################################################################
        ##############################################################################################
        
        menuAideApropos = menuAide.Append(wx.ID_ABOUT,'About...', u"About this software...")
        self.Bind(wx.EVT_MENU, self.onApropos, menuAideApropos)
                
        barreMenu.Append(self.menuModule, u"&Modules") 
        barreMenu.Append(menuAide, "&Help")
        
        self.SetMenuBar(barreMenu)
        
      
        #--------------------- Cration des widgets ----------------------------------
        # Taille des boutons
        colSize = (200,-1)
        
        # titres 
        font = wx.Font(12, wx.SWISS, wx.NORMAL, wx.BOLD)
        titreConversion = wx.StaticText(panel, -1, u'Conversions', size=colSize, style=wx.ALIGN_CENTRE)
        titreConversion.SetFont(font)
        titreCalcul = wx.StaticText(panel, -1, u"Electricity", size=colSize, style=wx.ALIGN_CENTRE)
        titreCalcul.SetFont(font)
        titreSonoVideo = wx.StaticText(panel, -1, u"Audio - Video",size=colSize, style=wx.ALIGN_CENTER)
        titreSonoVideo.SetFont(font)
        titreClimatic = wx.StaticText(panel, -1, u"Heating / Air-Cond.",size=colSize, style=wx.ALIGN_CENTRE)
        titreClimatic.SetFont(font)
        titreEclairage = wx.StaticText(panel, -1, u"Lighting",size=colSize, style=wx.ALIGN_CENTRE)
        titreEclairage.SetFont(font)
        
        # bouton section de cble
        self.btnSection = wx.Button(panel, -1, u"Cable cross-section", size=colSize)
        self.btnSection.SetToolTip(u"calculate cross-section of cable")
        self.Bind(wx.EVT_BUTTON, self.onSection, self.btnSection)
        
        # button "Voltage drop"
        self.btnChute = wx.Button(panel, -1, u"Voltage drop", size=colSize)
        self.btnChute.SetToolTip(u"calculate voltage drop of cable")
        self.Bind(wx.EVT_BUTTON, self.onChute, self.btnChute)
        
        # bouton Conversions
        self.btnConv = wx.Button(panel, -1, "Conversions", size=colSize)
        self.btnConv.SetToolTip(u"Convertir Watts en Ampres, CV et HP...")
        self.Bind(wx.EVT_BUTTON, self.onConversion, self.btnConv)
        
        # bouton Conversion AWG
        self.btnConvAwg = wx.Button(panel, -1, "Conversion AWG", size=colSize)
        self.btnConvAwg.SetToolTip("Convertir des AWG en mm")
        self.Bind(wx.EVT_BUTTON, self.onConvAwg, self.btnConvAwg)
        
        # bouton Vido
        self.btnVideo = wx.Button(panel, -1, "Fields of view", size=colSize)
        self.btnVideo.SetToolTip(u"Calculate fields of view as a function of focal lengths and distances")
        self.Bind(wx.EVT_BUTTON, self.onVideo, self.btnVideo)
        
        # bouton Sono
        self.btnSono = wx.Button(panel, -1, "Sound system", size=colSize)
        self.btnSono.SetToolTip(u"Calculate the number of HP and the required power")
        self.Bind(wx.EVT_BUTTON, self.onSono, self.btnSono)
        
        # bouton thermique 
        self.btnChauff = wx.Button(panel, -1, "Balances", size=colSize)
        self.btnChauff.SetToolTip(u"Heat/cold balances of a room...")
        self.Bind(wx.EVT_BUTTON, self.onClimatic, self.btnChauff)
        
        
        # bouton Eclairage
        self.btnEcl = wx.Button(panel, -1, u"Interior lighting", size=colSize)
        self.btnEcl.SetToolTip(
            u"Estimating the number of lighting fixtures required\n"
            u"according to the desired level of illumination")
        self.Bind(wx.EVT_BUTTON, self.onEclairage, self.btnEcl)
        
        self.Bind(wx.EVT_CLOSE, self.onQuitter)
        
        ############### Ajout des wigets au sizer ####################
        
        self.gbs.Add(titreCalcul, (0,0))
        self.gbs.Add(self.btnSection, (1,0))
        self.gbs.Add(self.btnChute, (2,0))
        
        self.gbs.Add(titreConversion, (0,1))
        self.gbs.Add(self.btnConv, (1,1))
        self.gbs.Add(self.btnConvAwg, (2,1))
        
        self.gbs.Add(titreSonoVideo, (0,2))
        self.gbs.Add(self.btnVideo, (1,2))
        self.gbs.Add(self.btnSono, (2,2))
        
        self.gbs.Add(titreClimatic, (4,0))
        self.gbs.Add(self.btnChauff, (5,0))

        self.gbs.Add(titreEclairage, (4,1))
        self.gbs.Add(self.btnEcl, (5,1))
                
        panel.SetSizerAndFit(self.gbs)
        self.SetClientSize(panel.GetSize())
        
        self.Centre() # centres the window when it opens on the screen
        
        
        
        #---- check for updates (if active) ----#
        #if self.Maj == 1 :
        if 0 :  # de-activated because web-site does not exist anymore!
            try :
                import urllib
                #---- Affichage du splash -----# ToDo: vorbergehend de-aktiviert!
                #splash = MySplashScreen()
                #splash.Show()
                
                def chargePage(url):
                    """loads the specified url and returns the page"""
                    from urllib.request import urlopen
                    http = urlopen(url)
                    content = http.read()
                    http.close()
                    return content
                
                urlbase= "http://www.sg-logiciels.fr/version_coban.txt"
                
                # load the coban.txt file and extract the version number and changelog
                # (separated by a ';' in the file)
                buffer= chargePage(urlbase)
                version = u''
                changes = u''
                # search for ';' and write the version and the changelog
                saut = 0
                try :
                    for char in buffer :
                        if char == ';' :
                            saut = 1
                        if saut == 0 :
                            version += char
                        if saut == 1 :
                            changes += char
                # if accented char in the file coban.txt
                except :
                    changes += ' (...)'
                # remove the ';' at the beginning of the changelog
                changes= changes[1:]
                if version != Version :
                    dlg = wx.MessageDialog(self, u'Version (%s) is available!'
                                           u'\n\nChanges: '
                                           u'\n%s'%(version,changes),
                                           'New version!',wx.OK | wx.ICON_INFORMATION)
                    dlg.ShowModal()
                    dlg.Destroy()
            except :
                wx.MessageBox(u"Impossible to check for updates!\n\n"
                              u"La recherche automatique de mise  jour\n"
                              u"sera dsactive au prochain dmarrage\n"
                              u"de Coban...\n"
                              u"(vous pouvez modifier ce paramtre dans le menu\n"
                              u"'Help > Preferences'\n",
                              u'Error!',
                              wx.ICON_WARNING)
                self.Maj = 0
                f = open(fichierConf, 'w')
                pickle.dump(self.cheminParDef,f)
                pickle.dump(self.Maj, f)
                f.close()
            
    def onSection(self, evt):
        import section
        section.Section(self)

    def onChute(self, evt):
        import chute
        self.dlg = chute.ModuleChute(self)
        self.btnChute.Enable(False)
        self.menuModuleChute.Enable(False)
        icone(self.dlg)
        self.dlg.Show(True)
        

    def onConversion(self, evt):
        import conversion
        self.dlg = conversion.ModuleConv(self)
        self.btnConv.Enable(False)
        self.menuModuleConversion.Enable(False)
        icone(self.dlg)
        self.dlg.Show(True)
        
    def onConvAwg(self, evt):
        import convawg
        self.dlg = convawg.Awg(self)
        self.btnConvAwg.Enable(False)
        self.menuModuleConvAwg.Enable(False)
        icone(self.dlg)
        self.dlg.Show(True)
        
    def onVideo(self, evt):
        import video
        self.dlg = video.Video(self)
        self.btnVideo.Enable(False)
        self.menuModuleVideo.Enable(False)
        icone(self.dlg)
        self.dlg.Show(True)
        
    def onSono(self, evt):
        import sono
        self.dlg = sono.Sono(self)
        self.btnSono.Enable(False)
        self.menuModuleSono.Enable(False)
        icone(self.dlg)
        self.dlg.Show(True)
        
    def onClimatic(self, evt):
        import climatic
        self.dlg = climatic.Climatic(self)
        self.btnChauff.Enable(False)
        self.menuModuleChauffage.Enable(False)
        icone(self.dlg)
        self.dlg.Show(True)
        
        
    def onEclairage(self,evt):
        import eclairage
        self.dlg = eclairage.Eclairage(self)
        self.btnEcl.Enable(False)
        self.menuModuleEcl.Enable(False)
        icone(self.dlg)
        self.dlg.Show(True)
        
    def onMaJ(self, evt):
        """ crit en 2me position dans le fichier
        'config.cob' 0 ou 1 selon si la notification des MJ
        est active ou pas..."""
        if self.menuMaJauto.IsChecked() == False :
            self.Maj = 0
        else :
            self.Maj = 1
        f = open(fichierConf, 'w')
        pickle.dump(self.cheminParDef,f)
        pickle.dump(self.Maj, f)
        f.close()
    
        
    def onPreferencesSauvegarde(self, evt):
        dlg = wx.DirDialog(self, u"Choisissez un rpertoire de sauvegarde :")
        
        if dlg.ShowModal() == wx.ID_OK:
            try :
                os.mkdir(os.path.join(dlg.GetPath(), '.coban'))
                f = open(fichierConf, 'w')
                pickle.dump(os.path.join(dlg.GetPath(), '.coban'), f)
                pickle.dump(self.Maj, f)
                f.close()
                wx.MessageBox(u'Vous avez choisi "%s" comme rpertoire de sauvegarde.\n'
                              u'Le dossier ".coban" y est cre.'
                              u'\n\nCoban doit tre relanc pour que les modifications soient prise en compte.'%dlg.GetPath(),
                              u'Attention !',
                              wx.ICON_EXCLAMATION
                              )
            except :
                wx.MessageBox(u"Vous n'avez pas les droits ncessaires pour crire dans le dossier :\n%s\n\n"
                              u"Certains modules ne fonctionneront pas\n\n"
                              u"Contactez votre administrateur systme pour vous donner les droits ncessaires, "
                              u"ou modifiez manuellement le fichier :\n%s\n\n"
                              u"(consultez l'aide de Coban ou le site\n"
                              u"http://sg-logiciels.fr pour plus d'informations)." %(os.getcwd(), os.path.join(os.getcwd(), fichierConf)),
                              u'Erreur !',
                              wx.ICON_WARNING)
                
            
            dlg.Destroy()
            sys.exit()
        else :
##            wx.MessageBox(u"Vous n'avez pas modifi le rpertoire de sauvegarde.",
##                          u'Attention !',
##                          wx.ICON_EXCLAMATION
##                          )
            dlg.Destroy()
            
            
        
    ###########################################################################################
    ###################################### pour Windows #######################################
    def onEnregistrement(self, evt):
        
        class TestDialog(wx.Dialog):
            def __init__(
                    self, parent, ID, title, size=wx.DefaultSize, pos=wx.DefaultPosition, 
                    style=wx.DEFAULT_DIALOG_STYLE,
                    ):
                
                pre = wx.PreDialog()
                pre.SetExtraStyle(wx.DIALOG_EX_CONTEXTHELP)
                pre.Create(parent, ID, title, pos, size, style)
                self.PostCreate(pre)
                
                sizer = wx.BoxSizer(wx.VERTICAL)
                
                box = wx.BoxSizer(wx.HORIZONTAL)
                label = wx.StaticText(self, -1, u"             www.sg-logiciels.fr\npour obtenir votre code de dblocage")
                box.Add(label, 0, wx.ALIGN_CENTRE|wx.ALL, 5)
                sizer.Add(box, 0, wx.GROW|wx.ALIGN_CENTER_VERTICAL|wx.ALL, 5)
                
                line = wx.StaticLine(self, -1, size=(20,-1), style=wx.LI_HORIZONTAL)
                sizer.Add(line, 0, wx.GROW|wx.ALIGN_CENTER_VERTICAL|wx.RIGHT|wx.TOP, 5)
                
                box = wx.BoxSizer(wx.HORIZONTAL)
                label = wx.StaticText(self, -1, u"Numro de facture :")
                box.Add(label, 0, wx.ALIGN_CENTRE|wx.ALL, 5)
                self.textLicence = wx.TextCtrl(self, -1, "", size=(100,-1))
                box.Add(self.textLicence, 1, wx.ALIGN_CENTRE|wx.ALL, 5)
                
                sizer.Add(box, 0, wx.GROW|wx.ALIGN_CENTER_VERTICAL|wx.ALL, 5)
                
                box = wx.BoxSizer(wx.HORIZONTAL)
                label = wx.StaticText(self, -1, u"Code de dblocage :")
                box.Add(label, 0, wx.ALIGN_CENTRE|wx.ALL, 5)
                self.textCode = wx.TextCtrl(self, -1, "", size=(200,-1))
                box.Add(self.textCode, 1, wx.ALIGN_CENTRE|wx.ALL, 5)
                
                sizer.Add(box, 0, wx.GROW|wx.ALIGN_CENTER_VERTICAL|wx.ALL, 5)
                
                line = wx.StaticLine(self, -1, size=(20,-1), style=wx.LI_HORIZONTAL)
                sizer.Add(line, 0, wx.GROW|wx.ALIGN_CENTER_VERTICAL|wx.RIGHT|wx.TOP, 5)
                
                btnsizer = wx.StdDialogButtonSizer()
                
                btn = wx.Button(self, wx.ID_OK)
                btn.SetDefault()
                btnsizer.AddButton(btn)
                
                btn = wx.Button(self, wx.ID_CANCEL)
                btnsizer.AddButton(btn)
                btnsizer.Realize()
                
                sizer.Add(btnsizer, 0, wx.ALIGN_CENTER_VERTICAL|wx.ALL, 5)
                
                self.SetSizer(sizer)
                sizer.Fit(self)
        
        #---------------------------------------------------------------------------
        
        
        dlg = TestDialog(self, -1, u"Enregistrement", size=(400, 200),
                         style=wx.DEFAULT_DIALOG_STYLE
                         )
        dlg.CenterOnScreen()

        val = dlg.ShowModal()
    
        if val == wx.ID_OK:
            config = []
            config.append(dlg.textLicence.GetValue())
            config.append(dlg.textCode.GetValue().upper())
            
            f = open(fichierConf, 'r')
            self.cheminParDef = pickle.load(f)
            f.close()
            
            try :
                f = open(os.path.join(os.path.expanduser(self.cheminParDef), 'licence.cob'), 'w')
                pickle.dump(config, f)
                f.close()
                wx.MessageBox(u"\n\nCoban must be restarted for the registration to take effect.",
                          u'Attention!',
                          wx.ICON_EXCLAMATION
                          )
                dlg.Destroy()
            except :
                wx.MessageBox(u"Vous n'avez pas les droits ncessaires pour crire dans le dossier :\n%s\n\n"
                              u"Certains modules ne fonctionneront pas\n\n"
                              u"Contactez votre administrateur systme pour vous donner les droits ncessaires, "
                              u"ou modifiez manuellement le fichier :\n%s\n\n"
                              u"(consultez l'aide de Coban ou le site\n"
                              u"http://www.sg-logiciels.fr pour plus d'informations)." %(os.getcwd(), os.path.join(os.getcwd(), fichierConf)),
                              u'Erreur !',
                              wx.ICON_WARNING)
                dlg.Destroy()
            sys.exit()
            
        else:
            dlg.Destroy()
        
        
    #######################################################################################################
        
        
    def onQuitter(self, evt):
        """Quitter l'application"""
        self.Destroy()

    def onAide(self, evt):
        # ouvre le fichier d'aide dans le navigateur de l'OS si possible
        try :
            import webbrowser
            chemin = "help.html"
            chemin = os.path.normpath(chemin)
            webbrowser.open(chemin)
        # sinon le faire manuellement
        except :
            wx.MessageBox(u'impossible d\'ouvrir le fichier d\'aide.\n'
                          u'Consultez le fichier d\'aide se trouvant dans '
                          u'le rpertoire d\'installation de Coban\n\n'
                          u'(Par exemple C:\\Program Files\\Coban\help.html sous Windows)',
                          u'Attention !',
                          wx.ICON_EXCLAMATION)

    
    def onApropos(self, evt):
        info = wx.AboutDialogInfo()
        info.Name = "Coban"
        info.Version = "%s" % Version
        info.WebSite = "http://www.sg-logiciels.fr"
        licenseText = (u"\n\nCoban est un programme informatique destin aux lectriciens et" 
                       u"\npermettant d'estimer rapidement la section d'un cble, de raliser des"
                       u"\nconversions d'units lectriques, etc.... "
                       u"\n\nVoir la Licence pour plus de dtails"
                       u"\n( voir le fichier \"licence.txt\")")
        info.Description = (u"Coban est un utilitaire destin aux lectriciens \n"
                            u"et permettant d'estimer rapidement la section d'un cble,\n"
                            u"de raliser des conversions d'units lectriques, etc..."
                            u'\n\nVoir le fichier "licence.txt" pour consulter la licence d\'utilisation.' 
                            u"\n\nPour tout contact, visiter le site :")
        info.Developers = [ u"Stphan GURIN | contact@sg-logiciels.fr"]
        info.Licence = licenseText
        wx.AboutBox(info)   
        
        
        
def main():
    app = Coban(False)
    app.MainLoop()

#if __name__ == "__main__":
    #app = Coban()
    #app.MainLoop()
